/* DATAFILE.HPP */ 
/* Copyright Dave Curtis 1994 */ 
/* dcurtis@hgmp.mrc.ac.uk */ 
/* no warranty or liability of any kind is accepted, expressed or implied */ 
 
/* DATAFILE.HPP */ 
/* Copyright Dave Curtis 1991 */ 
#ifndef DATAFILEHPP
#define DATAFILEHPP 1

#include <stdio.h>
#ifdef __ZTC__
#include <io.h>
#endif

class data_object;
class dcarray;

class data_file
{
friend class data_object;
friend class dcarray;
protected:
FILE *fp;
char *filename;
public:
data_file();
virtual ~data_file();
int open(char *s,char *rw);
int fgetc() { return ::fgetc(fp); }
int fseek(long offset,int origin) { return ::fseek(fp,offset,origin); }
long ftell() { return ::ftell(fp); }
char *fgets(char *s,int l=240) { return ::fgets(s,l,fp); }
fprintf(const char *format,...);
void close();
};

class data_object
{
protected:
FILE *get_fp(data_file &file) { return file.fp; }
public:
// really an error to call these, but cannot be 0
// because need to set up gdcarray(person)
virtual char *label() { return 0; }
virtual int input(data_file& file) { return 0; }
virtual int output(data_file& file) { return 0; }
virtual ~data_object() {;}
data_object();
};

#endif

